
 figure(1)
 streamslice(plon,plat,u_btrop(:,:),v_btrop(:,:));
 xlabel('Longitude');
 ylabel('Latitude');

%%%%%%%% Interpolation of V and U on the PSI-Q-grid

%remove Nan on land and allow below interpolation
v_btrop(  1,:)=0;
v_btrop(jdm,:)=0;
u_btrop(:,  1)=0;
u_btrop(:,idm)=0;


%free slip condition
 free=1;
%no slip
% free=0

 for ir=1:jdm
     if(free==1)
        vb_q(ir,1)=v_btrop(ir,1);
     else
        vb_q(ir,1)=0;
     end
     for ic=2:idm-1
        vb_q(ir,ic)=0.5*(v_btrop(ir,ic)+v_btrop(ir,ic-1));
     end
     if(free==1)
        vb_q(ir,idm)=v_btrop(ir,idm-1);
     else
        vb_q(ir,idm)=0;
     end
 end


 for ic=1:idm
     if(free==1)
        ub_q(1,ic)=u_btrop(1,ic);
     else
        ub_q(1,ic)=0;
     end			
     for ir=2:jdm-1
        ub_q(ir,ic)=0.5*(u_btrop(ir,ic)+u_btrop(ir-1,ic));
     end
     if(free==1)
        ub_q(jdm,ic)=u_btrop(jdm-1,ic);
     else
        ub_q(jdm,ic)=0;
     end
 end

%%%%%%%% Interpolation of depth on the PSI-Q-grid
 for ir=2:jdm-1
     for ic=2:idm-1
        depthq(ir,ic)=0.25*(depth(ir,ic)+depth(ir,ic-1)+depth(ir-1,ic)+depth(ir-1,ic-1));
     end
 end
 for ir=2:jdm-1
     depthq(ir,  1)=0.5*(depth(ir,    1)+depth(ir-1,    1));
     depthq(ir,idm)=0.5*(depth(ir,idm-1)+depth(ir-1,idm-1));
 end
 for ic=2:idm-1
     depthq(  1,ic)=0.5*(depth(    1,ic)+depth(    1,ic-1));
     depthq(jdm,ic)=0.5*(depth(jdm-1,ic)+depth(jdm-1,ic-1));
 end
 depthq(  1,  1)=depth(    1,    1)
 depthq(jdm,  1)=depth(jdm-1,    1)
 depthq(  1,idm)=depth(    1,idm-1)
 depthq(jdm,idm)=depth(jdm-1,idm-1)


%%%%%%%%%%%%%%%%%%%%%  USING V
 figure(100) 

%--- transport streamfunction using V on q-grid from WEST

 for ir=jdm:-1:1
     psi_vw(ir,1)=0.0;
     sum_trans=0.0;
     for ic=2:idm
         cell_trans=v_btrop(ir,ic)*depthq(ir,ic)*qscx(ir,ic);
         sum_trans=cell_trans+sum_trans;
         psi_vw(ir,ic)=sum_trans;
     end
 end
 
 psi_vw=psi_vw./1E6; %to express in sverdrup
 
 clev=[-1:0.1:1];
 [c,h]=contour(vlon,vlat,psi_vw,clev); h=clabel(c,h,clev);
 set(h,'BackgroundColor',[1 1 0.6]);
 %caxis([clev(1) clev(end)]);
 %colorbar; 
 xlabel('Longitude');
 ylabel('Latitude');
 title('On the v-grid using V from West (Sv)');

%%%%%%%%%%%%%%%%%%%%%  USING V
 figure(2) 

		
%--- transport streamfunction using V on v-grid from EAST

 for ir=jdm:-1:1
     psi_ve(ir,idm)=0.0;
     sum_trans=0.0;
     for ic=idm-1:-1:1
         cell_trans=v_btrop(ir,ic)*depthv(ir,ic)*vscx(ir,ic);
         sum_trans=cell_trans+sum_trans;
         psi_ve(ir,ic)=-sum_trans;
     end
 end
 
 psi_ve=psi_ve./1E6; %to express in sverdrup
 
 subplot(2,2,1)
 clev=[-1:0.1:1];
 [c,h]=contour(vlon,vlat,psi_ve,clev); h=clabel(c,h,clev);
 set(h,'BackgroundColor',[1 1 0.6]);
 %caxis([clev(1) clev(end)]);
 %colorbar; 
 xlabel('Longitude');
 ylabel('Latitude');
 title('On the v-grid using V from East (Sv)');


%--- transport streamfunction using V on v-grid from WEST

 for ir=jdm:-1:1
     psi_vw(ir,1)=0.0;
     sum_trans=0.0;
     for ic=2:idm
         cell_trans=v_btrop(ir,ic)*depthv(ir,ic)*vscx(ir,ic);
         sum_trans=cell_trans+sum_trans;
         psi_vw(ir,ic)=sum_trans;
     end
 end
 
 psi_vw=psi_vw./1E6; %to express in sverdrup
 
 subplot(2,2,2)
 clev=[-1:0.1:1];
 [c,h]=contour(vlon,vlat,psi_vw,clev); h=clabel(c,h,clev);
 set(h,'BackgroundColor',[1 1 0.6]);
 %caxis([clev(1) clev(end)]);
 %colorbar; 
 xlabel('Longitude');
 ylabel('Latitude');
 title('On the v-grid using V from West (Sv)');

%--- transport streamfunction using V on p-grid from EAST

 for ir=jdm-1:-1:1
     psi_vpe(ir,idm-1)=0.0;
     sum_trans=0.0;
     for ic=idm-2:-1:1
         cell_trans=vb_p(ir,ic)*depth(ir,ic)*pscx(ir,ic);
         sum_trans=cell_trans+sum_trans;
         psi_vpe(ir,ic)=-sum_trans;
     end
 end

 psi_vpe=psi_vpe./1E6; %to express in sverdrup 

 subplot(2,2,3)
 clev=[-1:0.1:1];
 [c,h]=contour(plon(1:end-1,1:end-1),plat(1:end-1,1:end-1),psi_vpe,clev); h=clabel(c,h,clev);
 set(h,'BackgroundColor',[1 1 0.6]);
 %caxis([clev(1) clev(end)]);
 %colorbar; 
 xlabel('Longitude');
 ylabel('Latitude');
 title('On the p-grid using V from East (Sv)');

%--- transport streamfunction using V on p-grid from WEST

 for ir=jdm-1:-1:1
     psi_vpw(ir,1)=0.0;
     sum_trans=0.0;
     for ic=2:idm-1
         cell_trans=vb_p(ir,ic)*depth(ir,ic)*pscx(ir,ic);
         sum_trans=cell_trans+sum_trans;
         psi_vpw(ir,ic)=sum_trans;
     end
 end

 psi_vpw=psi_vpw./1E6; %to express in sverdrup 

 subplot(2,2,4)
 clev=[-1:0.1:1];
 [c,h]=contour(plon(1:end-1,1:end-1),plat(1:end-1,1:end-1),psi_vpw,clev); h=clabel(c,h,clev);
 set(h,'BackgroundColor',[1 1 0.6]);
 %caxis([clev(1) clev(end)]);
 %colorbar; 
 xlabel('Longitude');
 ylabel('Latitude');
 title('On the p-grid using V from West (Sv)');


%%%%%%%%%%%%%%%%%%%%%  USING U
 figure(3)

%--- transport streamfunction using U on u-grid from NORTH

 for ic=idm:-1:1
     psi_un(jdm,ic)=0.0;
     sum_trans=0.0;
     for ir=jdm-1:-1:1
         cell_trans=u_btrop(ir,ic)*depthu(ir,ic)*uscy(ir,ic);
         sum_trans=cell_trans+sum_trans;
         psi_un(ir,ic)=sum_trans;
     end
 end
 
 psi_un=psi_un./1E6; %to express in sverdrup

 subplot(2,2,1)
 clev=[-1:0.1:1];
 [c,h]=contour(ulon,ulat,psi_un,clev); h=clabel(c,h,clev);
 set(h,'BackgroundColor',[1 1 0.6]);
 %caxis([clev(1) clev(end)]);
 %colorbar; 
 xlabel('Longitude');
 ylabel('Latitude');
 title('On the u-grid using U from North (Sv)');

	
%--- transport streamfunction using U on u-grid from SOUTH

 for ic=idm:-1:1
     psi_us(1,ic)=0.0;
     sum_trans=0.0;
     for ir=2:jdm
         cell_trans=u_btrop(ir,ic)*depthu(ir,ic)*uscy(ir,ic);
         sum_trans=cell_trans+sum_trans;
         psi_us(ir,ic)=-sum_trans;
     end
 end
 
 psi_us=psi_us./1E6; %to express in sverdrup

 subplot(2,2,2)
 clev=[-1:0.1:1];
 [c,h]=contour(ulon,ulat,psi_us,clev); h=clabel(c,h,clev);
 set(h,'BackgroundColor',[1 1 0.6]);
 %caxis([clev(1) clev(end)]);
 %colorbar; 
 xlabel('Longitude');
 ylabel('Latitude');
 title('On the u-grid using U from South (Sv)');

%--- transport streamfunction using U on p-grid from NORTH

 for ic=idm-1:-1:1
     psi_upn(jdm-1,ic)=0.0;
     sum_trans=0.0;
     for ir=jdm-2:-1:1
         cell_trans=ub_p(ir,ic)*depth(ir,ic)*pscy(ir,ic);
         sum_trans=cell_trans+sum_trans;
         psi_upn(ir,ic)=sum_trans;
     end
 end
 
 psi_upn=psi_upn./1E6; %to express in sverdrup 

 subplot(2,2,3)
 clev=[-1:0.1:1];
 [c,h]=contour(plon(1:end-1,1:end-1),plat(1:end-1,1:end-1),psi_upn,clev); h=clabel(c,h,clev);
 set(h,'BackgroundColor',[1 1 0.6]);
 %caxis([clev(1) clev(end)]);
 %colorbar; 
 xlabel('Longitude');
 ylabel('Latitude');
 title('On the p-grid using U from North (Sv)');


%--- transport streamfunction using U on p-grid from SOUTH

 for ic=idm-1:-1:1
     psi_ups(1,ic)=0.0;
     sum_trans=0.0;
     for ir=2:jdm-1
         cell_trans=ub_p(ir,ic)*depth(ir,ic)*pscy(ir,ic);
         sum_trans=cell_trans+sum_trans;
         psi_ups(ir,ic)=-sum_trans;
     end
 end
 
 psi_ups=psi_ups./1E6; %to express in sverdrup 

 subplot(2,2,4)
 clev=[-1:0.1:1];
 [c,h]=contour(plon(1:end-1,1:end-1),plat(1:end-1,1:end-1),psi_ups,clev); h=clabel(c,h,clev);
 set(h,'BackgroundColor',[1 1 0.6]);
 %caxis([clev(1) clev(end)]);
 %colorbar; 
 xlabel('Longitude');
 ylabel('Latitude');
 title('On the p-grid using U from South (Sv)');



%%%%%%%%%%%%%%%%%%%%%%%%%%% Velocity

 scale_fact =20000;
 reference=1e-4;
 ref_str=num2str(reference);
 pic_incr=5.0;
 skipX=2;
 skipY=2;

 img=sqrt(-1);
 

 figure(4)
  arrows(plon(1:skipX:end-1,1:skipY:end-1),plat(1:skipX:end-1,1:skipY:end-1),ub_p(1:skipX:end,1:skipY:end)+img*vb_p(1:skipX:end,1:skipY:end),scale_fact,'k');
  hold on
  arrows(50.0,-3.0,reference,scale_fact,'b');
  text(50.0,-2.5,[ref_str,' m/s'],'color','b');
  hold off
 
  if(exist('tstep_str')==1);
    time_str=num2str(timestep);
    title(['Expt ',expstr,' Timestep ',time_str]) 
  else    
    title(['Barotropic Velocity  Expt ',expstr,' Year ',num2str(year),' Day ',num2str(day),' Hour ',num2str(hour),' skipX/Y ',num2str(skipX),'/',num2str(skipY)])
  end %if
    axis([min(min(plon))-pic_incr max(max(plon))+pic_incr min(min(plat))-pic_incr max(max(plat))+pic_incr])
 xlabel('Longitude');
 ylabel('Latitude');
