clear
close all

disp('----- NUM. OF EXPT --------');
expt=input('expt?--------------->');

%loads output of the specified expt
expt=expt*10;
savefile=['0',num2str(expt),'.mat'];
load(savefile);

%free slip condition
% free=1
%no slip
 free=0

for it=1:itmax

%remove Nan on land and allow below interpolation
 u_btrop(:,  1,it)=0;
 u_btrop(:,idm,it)=0;

%%%%%%%% Interpolation of U on the PSI-Q-grid
 for ic=1:idm
     if(free==1)
        ub_q(1,ic,it)=u_btrop(1,ic,it);
     else
        ub_q(1,ic,it)=0;
     end			
     for ir=2:jdm-1
        ub_q(ir,ic,it)=0.5*(u_btrop(ir,ic,it)+u_btrop(ir-1,ic,it));
     end
     if(free==1)
        ub_q(jdm,ic,it)=u_btrop(jdm-1,ic,it);
     else
        ub_q(jdm,ic,it)=0;
     end
 end

%remove Nan on land and allow below interpolation
 v_btrop(  1,:,it)=0;
 v_btrop(jdm,:,it)=0;

%%%%%%%% Interpolation of V on the Q-grid

 for ir=1:jdm
     if(free==1)
        vb_q(ir,1,it)=v_btrop(ir,1,it);
     else
        vb_q(ir,1,it)=0;
     end
     for ic=2:idm-1
        vb_q(ir,ic,it)=0.5*(v_btrop(ir,ic,it)+v_btrop(ir,ic-1,it));
     end
     if(free==1)
        vb_q(ir,idm,it)=v_btrop(ir,idm-1,it);
     else
        vb_q(ir,idm,it)=0;
     end
 end

end %itmax

scrsz=get(0,'ScreenSize');

figure(1)
set(1,'Position',[10 scrsz(4)/2-80 scrsz(3)/2 scrsz(4)/2]) %[left bottom
                                                       %width height]
%
% arrows:          draws arrows
%
% Usage: [h]=arrows(x,y,w,fac,[color])
%
% where: h ....... the returned handle
%
%        (x,y) ... the coordinates where the arrow should be plotted
%        w ....... the velocity vector (complex)
%        fac ..... scaling factor for vector
%        color ... color of vector
%
% Acknowledgement: this function draws heavily on the "omviz" package
% written by Rich Signell (USGS)
%
% Initial version, JRH 11/12/2001
%
% Geometry of arrowheads (choosing HEADA and HEADL):
%
%  If the arrow is defined by the points A B C B D where A is the base of 
%  the arrow, B is the head, and C and D are the corners of the arrowhead, then
%  HEADA is the angle BAC (or BAD), and HEADL is the ratio of distances AC/AB.
%

%---MAR explanation about the scale factor in arrows
%---MAR arrows plots in the unit of the page
%---MAR so if it is arrows(0,0,1+i*0,1) it plots an eastward arrow
%---MAR of one unit! So if I am using lon/lat and I am reading velocities
%---MAR of cm/sec it is clear that using a scale_fact=1 will lead to too
%---MAR big arrows! 
%---MAR

%%%%%%%%%%%%%%%%%%%%%%%%%%% Plot Velocity

 scale_fact =20000;
 reference=1e-4;
 ref_str=num2str(reference);
 pic_incr=5.0;
 skipX=1;
 skipY=1;

 img=sqrt(-1);

for it=1:itmax
    disp(it)
    if(  max(max(srfhgt(:,:,it)))==min(min(srfhgt(:,:,it)))  )
         surf(plon,plat,srfhgt(:,:,it)); view([0 90]); colorbar;
         hold on
         hold on         
         h=arrows(qlon(1:skipX:end,1:skipY:end),qlat(1:skipX:end,1:skipY:end),ub_q(1:skipX:end,1:skipY:end,it)+img*vb_q(1:skipX:end,1:skipY:end,it),scale_fact,'w');
         arrows(50.0,-3.0,reference,scale_fact,'b');
         text(50.0,-2.5,[ref_str,' m/s'],'color','b');
         hold off
    else    
         contourf(plon,plat,srfhgt(:,:,it)); colorbar;
         %    surf(plon,plat,srfhgt(:,:,it)); view([0 90]); colorbar;
         hold on         
         h=arrows(qlon(1:skipX:end,1:skipY:end),qlat(1:skipX:end,1:skipY:end),ub_q(1:skipX:end,1:skipY:end,it)+img*vb_q(1:skipX:end,1:skipY:end,it),scale_fact,'w');
         arrows(50.0,-3.0,reference,scale_fact,'b');
         text(50.0,-2.5,[ref_str,' m/s'],'color','b');
         hold off
    end %if
    title(['Velocity (Q-grid) Expt ',expstr,' Year ',title_str{it,1},' Day ',title_str{it,2},' Hour ',title_str{it,3}])
    axis([min(min(qlon))-pic_incr max(max(qlon))+pic_incr min(min(qlat))-pic_incr max(max(qlat))+pic_incr])
    set(gca,'Color',[.6 .6 .6]);
    pause
end %for

